﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Windows.Controls;
using System.Windows.Threading;

namespace VisualLinq
{
    public class VisualBucket<T> : VisualChild<T>, IVisualBucket
    {
        VisualEnumerable<T> parent;
        TextBlock result;

        public VisualBucket(VisualEnumerable<T> parent)
            : base(parent, "result")
        {
            this.parent = parent;
            result = new TextBlock();
            Canvas.Children.Add(result);
            Canvas.SetTop(result, Canvas.GetTop(Box) + Box.Height + 10);
            Canvas.SetLeft(result, Canvas.GetLeft(Box));
        }

        public void Go()
        {
            result.Text = "";
            (new Thread(FetchItems) { IsBackground=true }).Start();
        }

        void FetchItems()
        {
            foreach (T t in parent)
            {
                AnimateDataMovement(t.ToString());
                Canvas.Dispatcher.Invoke(DispatcherPriority.Normal, (Action<string>)AddResult, t.ToString());
            }
        }

        void AddResult(string item)
        {
            result.Text += item + "\r\n";
        }
    
        public override IEnumerator<T>  GetEnumerator()
        {
            yield break;
        }
    }
}
